
TYPO3.TypoScript - Bug # 38631

Feature # 38629 (Resolved): Make TypoScript usable outside the context of TYPO3 / Nodes, but also for building extensible FLOW3 applications

Status: Resolved Priority: Should have
Author: Sebastian Kurfuerst Category:
Created: 2012-07-04 Assigned To:
Updated: 2012-08-11 Due date:
Subject: Make use of FlowQuery explicit by introducing a wrapper function "q" (for "query")
Description

While FlowQuery expressions such as ${context.children('foo > bar[title^=Hi]')} are very concise and have a high expressional power
when it comes to TYPO3 Phoenix and TYPO3CR Nodes, it becomes cumbersome to work with objects this way. For objects,
normally, you only want to traverse the objects by calling getters and setters, or call some functions on them.

So, I propose a breaking change: FlowQuery should be used explicitely, i.e. by introducing a function q similar to the jQuery function.
Thus, the above text should be written as: ${q(context).children('foo > bar[title^=Hi]')}

Related issues:
blocks Foo.ContentManagement - Major Feature # 37293: Refactor Admin to work ... New 2012-05-18

Associated revisions
Revision ba74758a - 2012-08-11 15:26 - Sebastian Kurfuerst

[!!!][FEATURE] Make TypoScript Context multi-valued; make FlowQuery use explicit

Before, the TypoScript context only contained a single value which was
available in the template as "context". Inside TypoScript Eel expressions, we
automatically wrapped the context object with FlowQuery; so "context" inside
eel expressions was a wrapped context.

Now, we're untangling this:

    -  The TypoScript context can contain multiple named values, which are all
  directly available inside Eel expressions. So, if your context contains a
  variable "node", this is directly accessible inside Eel.

    -  FlowQuery must be explicitly used, by calling the "q" function (short for
  "Query").

    -  The hardcoded "context" variable inside Fluid templates has been removed; so
  all variables which should be available inside Fluid must be explicitly
  passed into the template.

In the context of Phoenix, before this change, one used f.e.
"context.property('title')". Now, he has to use "q(node).property('title')".

Backwards Compatibility=======================

Together with If043a53cb0556ca1d8e72ae05e269dcb8ee056f5, we are inserting a
backwards compatibility layer:

    -  "context" inside Eel expression is the same as "q(node)", so this is the same
  behavior as before
    -  "context" inside Fluid Templates is a reference to "node", as it was before.

Still, you should rewrite your templates as we will remove this compatibility
layer later on.

Note: We're merging two features as one change, as it is required in order to
      provide backwards compatible behavior.

Resolves: #38631
Resolves: #38633
Change-Id: I5b1863510d372d953c7a076c03214295d4f1131b

History
#1 - 2012-07-05 19:03 - Gerrit Code Review

Patch set 1 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12649

#2 - 2012-07-05 19:04 - Sebastian Kurfuerst
- Status changed from New to Accepted
- % Done changed from 0 to 30

#3 - 2012-07-09 15:16 - Christopher Hlubek

I can understand the reason behind that change, but I fear that TypoScript + Eel + FlowQuery is already quite complex. If we change anything, we
should try to keep it simple for TypoScript developers in 90% of the use cases. If you want to access the raw result you can write xyz.get() (if it is a
FlowQuery) or maybe we introduce a function to do that safely for any expression. But this is not necessarily be a feature for the average TypoScript
developer.

#4 - 2012-08-07 09:57 - Gerrit Code Review

Patch set 2 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12649

#5 - 2012-08-07 13:21 - Gerrit Code Review

Patch set 3 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12649

#6 - 2012-08-07 15:50 - Gerrit Code Review

Patch set 4 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12649

#7 - 2012-08-09 15:27 - Gerrit Code Review
Patch set 5 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12649

#8 - 2012-08-09 17:01 - Sebastian Kurfuerst
- Status changed from Accepted to Under Review

#9 - 2012-08-10 15:19 - Gerrit Code Review

Patch set 6 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12649

#10 - 2012-08-11 15:22 - Gerrit Code Review

Patch set 7 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12649

#11 - 2012-08-11 15:25 - Gerrit Code Review

Patch set 8 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12649

#12 - 2012-08-11 15:26 - Gerrit Code Review

Patch set 9 for branch master has been pushed to the review server.
It is available at http://review.typo3.org/12649

#13 - 2012-08-11 15:35 - Sebastian Kurfuerst
- Status changed from Under Review to Resolved
- % Done changed from 30 to 100

Applied in changeset commit:ba74758a233db47d1ad8fafe1dc88df76e55c5ad.
